From a97e1e5c665714b61d66886ec98a9a2a509003b3 Mon Sep 17 00:00:00 2001
From: Daniel Pimentel <d4n1@member.fsf.org>
Date: Sat, 17 Oct 2015 12:18:18 -0300
Subject: [PATCH 3/3] Translated 31% (line 2088)

* gnu: licenses/gpl-faq.pt-br.po: Updated it
---
 licenses/gpl-faq.pt-br.po | 175 +++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 172 insertions(+), 3 deletions(-)

diff --git a/licenses/gpl-faq.pt-br.po b/licenses/gpl-faq.pt-br.po
index 8b2083d..95a8537 100644
--- a/licenses/gpl-faq.pt-br.po
+++ b/licenses/gpl-faq.pt-br.po
@@ -5,6 +5,7 @@
 # Fernando Lozano, 2000.
 # Dec 2014: GNUNify and trivially update a few strings (T. Godefroy).
 # Rafael Beraldo, 2015.
+# Daniel Pimentel, 2015.
 #
 msgid ""
 msgstr ""
@@ -1042,6 +1043,11 @@ msgid ""
 "the explicit patent license grant I'm making&mdash;is it just the library, "
 "or is it the whole combination?</a>"
 msgstr ""
+"<a href=\"#LGPLv3ContributorVersion\">Se eu distribuir um programa proprietário "
+"que faz um link com uma biblioteca LGPLv3 que eu modifiquei, o que é a "
+"&ldquo;versão do contribuidor&rdquo; por razões de determinação de escopo da "
+"conceção da licença da patente explícita que concede que estou fazendo isso só para a biblioteca, "
+"ou é uma combinação completa?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1049,38 +1055,49 @@ msgid ""
 "Program under section 13, what Corresponding Source does it have to offer?</"
 "a>"
 msgstr ""
+"<a href=\"#AGPLv3CorrespondingSource\">Sob AGPLv3, quando eu modifiquei o "
+"programa sob a seção 13, o que o fonte correspondente tem a oferecer?</"
+"a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#LibGCCException\">Where can I learn more about the GCC Runtime "
 "Library Exception?</a>"
 msgstr ""
+"<a href=\"#LibGCCException\">Onde eu posso aprender mais sobre GCC Runtime "
+"Library Exception?</a>"
 
 #. type: Content of: <h4>
 msgid "Combining work with code released under the GNU licenses"
-msgstr ""
+msgstr "Combinando trabalho com código lançado sob a licença GNU"
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"#v2v3Compatibility\">Is GPLv3 compatible with GPLv2?</a>"
-msgstr ""
+msgstr "<a href=\"#v2v3Compatibility\">GPLv3 é compatíel com a GPLv2?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#AllCompatibility\">How are the various GNU licenses compatible "
 "with each other?</a>"
 msgstr ""
+"<a href=\"#AllCompatibility\">Como as diversas licenças GNU são compatíveis "
+"com as outras?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#GPLStaticVsDynamic\">Does the GPL have different requirements for "
 "statically vs dynamically linked modules with a covered work?</a>"
 msgstr ""
+"<a href=\"#GPLStaticVsDynamic\">A GPL tem requisitos diferentes para "
+"módulos ligados estaticamente vs dinamicamente em trabalho protegido?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#LGPLStaticVsDynamic\">Does the LGPL have different requirements "
 "for statically vs dynamically linked modules with a covered work?</a>"
 msgstr ""
+"<a href=\"#LGPLStaticVsDynamic\">A LGPL tem requisitos diferentes para "
+"módulos ligados estaticamente vs dinamicamente em trabalho protegido?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1174,6 +1191,8 @@ msgid ""
 "<a href=\"#NFUseGPLPlugins\">Can I release a non-free program that's "
 "designed to load a GPL-covered plug-in?</a>"
 msgstr ""
+"<a href=\"#NFUseGPLPlugins\">Eu posso lançar um programa não livre que está "
+"projetado para carregar um plugin sob GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1182,6 +1201,10 @@ msgid ""
 "module, under a GPL-compatible lax permissive license (such as the X11 "
 "license) in between the GPL-covered part and the proprietary part?</a>"
 msgstr ""
+"<a href=\"#GPLWrapper\">Eu gostaria de incorporar um software sob GPL em meu "
+"sistema proprietário. Eu posso fazer isso colocando um módulo &ldquo;empacotador&rdquo; "
+"sob uma licença permisiva compatível com GPL (tal como a licença X11) "
+"parte sob GPL e parte proprietária?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1196,12 +1219,16 @@ msgid ""
 "<a href=\"#SystemLibraryException\">Can I link a GPL program with a "
 "proprietary system library?</a>"
 msgstr ""
+"<a href=\"#SystemLibraryException\">Eu posso ligar um programa GPL com uma "
+"biblioteca de um sistema proprietário?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#GPLIncompatibleLibs\">What legal issues come up if I use GPL-"
 "incompatible libraries with GPL software?</a>"
 msgstr ""
+"<a href=\"#GPLIncompatibleLibs\">Quais problemas legais surgem se eu usar bibliotecas "
+"incompatíveis com GPL com softwares GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1237,6 +1264,11 @@ msgid ""
 "program, does that make the license GPL-compatible? Can I combine or link Q "
 "with a GPL-covered program?</a>"
 msgstr ""
+"<a href=\"#GPLIncompatibleAlone\">Se a licença para um módulo Q tem um "
+"requisito que é incompatível com a GPL, mas o requisito aplica-se "
+"somente quando o Q é distribuído por si mesmo, não quando Q é incluído em um programa "
+"maior, aquilo faz a licença GPL compatível? Eu posso combinar ou ligar Q "
+"com programas sob GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1253,6 +1285,8 @@ msgid ""
 "<a href=\"#NonfreeDriverKernelLinux\">Does distributing a nonfree driver "
 "meant to link with the kernel Linux violate the GPL?</a>"
 msgstr ""
+"<a href=\"#NonfreeDriverKernelLinux\">Distribuíndo um driver não livre "
+"que destina-se a ligar com o kernel Linux, viola a GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1260,6 +1294,9 @@ msgid ""
 "proprietary modules with my GPL-covered library under a controlled interface "
 "only?</a>"
 msgstr ""
+"<a href=\"#LinkingOverControlledInterface\">Como eu posso permitir ligações de "
+"módulos proprietários com minha biblioteca coberta pela GPL sob uma interface controlada "
+"somente?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1290,16 +1327,21 @@ msgid ""
 "source code within documentation that is licensed under some license that is "
 "incompatible with the GPL?</a>"
 msgstr ""
+"<a href=\"#SourceCodeInDocumentation\">Eu posso usar um fragmento de um código fonte sob GPL "
+"dentro da documentação que está licenciada sob alguma licença que é "
+"incompatível com a GPL?</a>"
 
 #. type: Content of: <h4>
 msgid "Questions about violations of the GNU licenses"
-msgstr ""
+msgstr "Questões sobre violações da licença GNU"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#ReportingViolation\">What should I do if I discover a possible "
 "violation of the GPL?</a>"
 msgstr ""
+"<a href=\"#ReportingViolation\">O que eu deveria fazer se eu descobrir uma possível "
+"violação da GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1324,12 +1366,16 @@ msgid ""
 "<a href=\"#SubscriptionFee\">Can I use GPLed software on a device that will "
 "stop operating if customers do not continue paying a subscription fee?</a>"
 msgstr ""
+"<a href=\"#SubscriptionFee\">Eu posso usar um software GPL sobre uma dispositivo que irá "
+"para de operar se os clientes não continuar o pagamento de uma taxa de assinatura?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"#Cure\">What does it mean to &ldquo;cure&rdquo; a violation of "
 "GPLv3?</a>"
 msgstr ""
+"<a href=\"#Cure\">O que significa &ldquo;remediar&rdquo; uma violação de "
+"GPLv3?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1337,6 +1383,9 @@ msgid ""
 "then lends that laptop to a friend without providing source code for the "
 "software, have they violated the GPL?</a>"
 msgstr ""
+"<a href=\"#LaptopLoan\">Se alguém instalar um software GPL sobre um laptop, e "
+"então emprestar esse laptop para um amigo sem prover o código fonte para o "
+"software, eles tem violado a GPL?</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -1346,6 +1395,11 @@ msgid ""
 "only runs signed software from the first company. Is this a violation of "
 "GPLv3?</a>"
 msgstr ""
+"<a href=\"#TwoPartyTivoization\" >Suponha que duas empresas tentam "
+"envolver o requisito para prover informações de instalação tendo uma "
+"empresa lançado um software assinado, e o outro lançado um produto para usuário que "
+"somente executa softwares assinados da primeira empresa. Isso é uma violação da "
+"GPLv3?</a>"
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1394,6 +1448,8 @@ msgid ""
 "Why should I use the GNU GPL rather than other free software licenses? <span "
 "class=\"anchor-reference-id\">(<a href=\"#WhyUseGPL\" >#WhyUseGPL</a>)</span>"
 msgstr ""
+"Porque eu deveria usar a GNU GPL em vez de outras licenças de software livre? <span "
+"class=\"anchor-reference-id\">(<a href=\"#WhyUseGPL\" >#WhyUseGPL</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1403,6 +1459,11 @@ msgid ""
 "your own work.  However, in some special situations it can be better to use "
 "a <a href=\"/licenses/why-not-lgpl.html\">more permissive license</a>."
 msgstr ""
+"Usando a GNU GPL irá requerer que todo as <a href=\"/philosophy/pragmatic."
+"html\">versões lançadas sejam software livre</a>.  Isso significa que você pode "
+"evitar o risco de ter que competir com versões modificadas proprietárias de "
+"seu próprio trabalho.  Contudo, em algumas situações especiais pode ser melhor usar "
+"a <a href=\"/licenses/why-not-lgpl.html\">licenças mais permissivas</a>."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1464,6 +1525,9 @@ msgid ""
 "\"anchor-reference-id\">(<a href=\"#ReportingViolation\" "
 ">#ReportingViolation</a>)</span>"
 msgstr ""
+"O que eu deveria fazer se eu descobrir uma possível violação da GPL? <span class="
+"\"anchor-reference-id\">(<a href=\"#ReportingViolation\" "
+">#ReportingViolation</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1475,6 +1539,13 @@ msgid ""
 "be the copyright holder, or else could tell you how to contact the copyright "
 "holder, so report it to the maintainer."
 msgstr ""
+"Você deve <a href=\"/licenses/gpl-violation.html\">reportá-lo</a>.  Primeiro, "
+"verifique os fatos como melhor você puder.  Então pergunte ao editor ou proprietário "
+"dos direitos autorais (copyright) do programa específico sob GPL.  Se for a Fundação do Software "
+"Livre, escreva para <a href=\"mailto:license-violation@gnu.org\">&lt;"
+"license-violation@gnu.org&gt;</a>.  Caso contrário, o mantenedor do programa pode "
+"ser o proprietário dos direitos autorais, ou também poderia dizer a você como contactar o proprietário do "
+"copyright, então reporte para o mantenedor."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1582,6 +1653,9 @@ msgid ""
 "same computer? <span class=\"anchor-reference-id\">(<a href="
 "\"#GPLAndNonfreeOnSameMachine\" >#GPLAndNonfreeOnSameMachine</a>)</span>"
 msgstr ""
+"Eu posso ter um programa sob GPL e um programa não livre não relacionado sobre o "
+"mesmo computador? <span class=\"anchor-reference-id\">(<a href="
+"\"#GPLAndNonfreeOnSameMachine\" >#GPLAndNonfreeOnSameMachine</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid "Yes."
@@ -1593,6 +1667,9 @@ msgid ""
 "me a copy? <span class=\"anchor-reference-id\">(<a href=\"#CanIDemandACopy\" "
 ">#CanIDemandACopy</a>)</span>"
 msgstr ""
+"Seu eu conhecer alguém que tem uma cópia de um programa sob GPL, eu posso exigir que ele me der "
+"uma cópia? <span class=\"anchor-reference-id\">(<a href=\"#CanIDemandACopy\" "
+">#CanIDemandACopy</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1600,6 +1677,9 @@ msgid ""
 "program <em>if and when he chooses to do so</em>.  He also has the right not "
 "to redistribute the program, when that is what he chooses."
 msgstr ""
+"Não.  A GPL dar a ele permissão para fazer e redistribuir cópias do "
+"programa <em>se e quando ele escolher fazê-lo</em>.  Ele também tem o direito de não "
+"redistribuir o programa, quando isso é o que ele escolhe."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1617,6 +1697,8 @@ msgid ""
 "If you choose to provide source through a written offer, then anybody who "
 "requests the source from you is entitled to receive it."
 msgstr ""
+"Se você escolhe prover os fontes através de oferta por escrito, então alguém quem "
+"solicitou os fontes de você está intitulado para recebê-lo."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1677,6 +1759,9 @@ msgid ""
 "program? <span class=\"anchor-reference-id\">(<a href="
 "\"#RequiredToClaimCopyright\" >#RequiredToClaimCopyright</a>)</span>"
 msgstr ""
+"Eu requisito reivindicar um copyright sobre minhas modificações para um programa sob "
+"GPL? <span class=\"anchor-reference-id\">(<a href="
+"\"#RequiredToClaimCopyright\" >#RequiredToClaimCopyright</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1685,6 +1770,10 @@ msgid ""
 "place your changes explicitly in the public domain if you do not want them "
 "to be copyrighted."
 msgstr ""
+"Você está requisitando reivindicações de um copyright sobre suas modificações. Na maioria "
+"dos paises, contudo, isso acontece automaticamente por padrão, então você precisa "
+"colocar suas modificações explicitamente no domínio público se você não quiser que "
+"seja com direitos do autor."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1693,6 +1782,10 @@ msgid ""
 "\"#GPLRequireSourcePostedPublic\">if you release your modified version at "
 "all</a>)."
 msgstr ""
+"Se você reivindica um copyright sobre suas mudanças ou não, de qualquer jeito você pode "
+"lançar a versão modificada, como um todo, sob a GPL (<a href="
+"\"#GPLRequireSourcePostedPublic\">se você lançar suas versões modifcadas de "
+"tudo</a>)."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1700,6 +1793,9 @@ msgid ""
 "language? <span class=\"anchor-reference-id\">(<a href=\"#TranslateCode\" "
 ">#TranslateCode</a>)</span>"
 msgstr ""
+"O que a GPL diz sobre tradução de algum código para uma linguagem de programação "
+"diferente? <span class=\"anchor-reference-id\">(<a href=\"#TranslateCode\" "
+">#TranslateCode</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1707,6 +1803,9 @@ msgid ""
 "modification.  Therefore, what the GPL says about modified versions applies "
 "also to translated versions."
 msgstr ""
+"Sobre a lei de copyright, traduções de um trabalho é considerado um tipo de "
+"modificação.  Portanto, o que a GPL diz sobre versões modificadas se aplica "
+"também para versões traduzidas."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1715,6 +1814,10 @@ msgid ""
 "\"anchor-reference-id\">(<a href=\"#CombinePublicDomainWithGPL\" "
 ">#CombinePublicDomainWithGPL</a>)</span>"
 msgstr ""
+"Se um programa combina código de domínio público com código GPL, eu posso pegar "
+"parte do domínio público e usá-lo como código de domínio público? <span class="
+"\"anchor-reference-id\">(<a href=\"#CombinePublicDomainWithGPL\" "
+">#CombinePublicDomainWithGPL</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1722,6 +1825,9 @@ msgid ""
 "and separate it from the rest.  If code was put in the public domain by its "
 "developer, it is in the public domain no matter where it has been."
 msgstr ""
+"Você pode fazê-lo, se você pode calcular que parte é de domínio público e  "
+"separar isso do resto. Se o código foi colocado no domínio público pelo "
+"desenvolvedor, isso é no domínio público não importa onde esteja."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1741,12 +1847,19 @@ msgid ""
 "charge.  (The one exception is the required written offer to provide source "
 "code that must accompany binary-only release.)"
 msgstr ""
+"Sim, a GPL permite todo mundo fazer isso.  O <a href=\"/philosophy/selling."
+"html\">direito de vender cópias</a> é parte da definição de software livre.  "
+"Exeto em uma situação especial, não há limite do preço que você pode "
+"alterar.  (A única exeção é a oferta por escrito requerida para prover o fonte"
+"do código que deve acompanhar o lançamento do binário somente.)"
 
 #. type: Content of: <dl><dt>
 msgid ""
 "Does the GPL allow me to charge a fee for downloading the program from my "
 "distribution site?"
 msgstr ""
+"A GPL me permite alterar a taxa para baixar o programa de meu "
+"site de distribuição?"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1755,6 +1868,10 @@ msgid ""
 "equivalent access&rdquo; to download the source&mdash;therefore, the fee to "
 "download source may not be greater than the fee to download the binary."
 msgstr ""
+"Sim.  Você pode alterar qualquer taxa que você desejar para distribuir uma cópia do "
+"programa.  Se você distribuir binários para baixar, você pode prover &ldquo;"
+"acesso equivalente&rdquo; para baixar o fonte&mdash;contudo, a taxa para "
+"baixar o fonte não pode ser maior que a taxa para baixar o binário."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1795,6 +1912,9 @@ msgid ""
 "\">get a copy <em>from you</em></a>.  You can't require people to pay you "
 "when they get a copy <em>from someone else</em>."
 msgstr ""
+"Você <em>pode</em> cobrar uma taxa para as pessoas <a href=\"#DoesTheGPLAllowMoney"
+"\">pegar uma cópia <em>de você</em></a>.  Você não pode requerer que as pessoas paguem para você "
+"quando eles pegam uma cópia <em>de alguém também</em>."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1803,6 +1923,10 @@ msgid ""
 "\"> (<a href=\"#DoesTheGPLRequireAvailabilityToPublic\" "
 ">#DoesTheGPLRequireAvailabilityToPublic</a>)</span>"
 msgstr ""
+"Se eu distribuir um software GPL por uma taxa, eu estou requerendo também que esteja "
+"disponível para o público sem uma cobrança? <span class=\"anchor-reference-id"
+"\"> (<a href=\"#DoesTheGPLRequireAvailabilityToPublic\" "
+">#DoesTheGPLRequireAvailabilityToPublic</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1811,6 +1935,10 @@ msgid ""
 "example, someone could pay your fee, and then put her copy on a web site for "
 "the general public."
 msgstr ""
+"Não. Contudo, se alguém pagar sua taxa e pegar uma cópia, a GPL dá então "
+"a liberdade para lançá-lo para o público, com ou sem uma taxa. Por "
+"exemplo, alguém poderia pagar sua taxa, e então colocar uma cópia dele sobre um web site para "
+"o público em geral."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1818,6 +1946,9 @@ msgid ""
 "<span class=\"anchor-reference-id\">(<a href=\"#DoesTheGPLAllowNDA\" "
 ">#DoesTheGPLAllowNDA</a>)</span>"
 msgstr ""
+"A GPL me permite distribuir cópias sob um acordo de não divulgação? "
+"<span class=\"anchor-reference-id\">(<a href=\"#DoesTheGPLAllowNDA\" "
+">#DoesTheGPLAllowNDA</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1825,6 +1956,9 @@ msgid ""
 "redistribute copies, modified or not.  You are not allowed to distribute the "
 "work on any more restrictive basis."
 msgstr ""
+"Não.  A GPL diz que quem receber uma cópia de você tem o direito para "
+"redistribuir cópias, modificadas ou não. Você não tem permissão para distribuir o "
+"o trabalho em qualquer base mais restrita."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1832,6 +1966,9 @@ msgid ""
 "copyrighted by the FSF, please inform us immediately by writing to <a href="
 "\"mailto:license-violation@fsf.org\">license-violation@fsf.org</a>."
 msgstr ""
+"Se alguém pergunta a você para assinar um NDA para receber um software GPL "
+"com direitos autorais para a FSF, porfavor informe-nos imediatamente escrevendo para <a href="
+"\"mailto:license-violation@fsf.org\">license-violation@fsf.org</a>."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1839,6 +1976,9 @@ msgid ""
 "holder, please inform that copyright holder, just as you would for any other "
 "kind of violation of the GPL."
 msgstr ""
+"Se a violação envolve códigos GPL que tem algum outro proprietário do "
+"copyright, porfavor informe ao proprietário, assim como você deveria para qualquer outros "
+"tipo de violação da GPL."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1846,6 +1986,9 @@ msgid ""
 "nondisclosure agreement? <span class=\"anchor-reference-id\">(<a href="
 "\"#DoesTheGPLAllowModNDA\" >#DoesTheGPLAllowModNDA</a>)</span>"
 msgstr ""
+"A GPL me permite distribuir uma versão modificada ou beta sob um "
+"acordo de não divulgação? <span class=\"anchor-reference-id\">(<a href="
+"\"#DoesTheGPLAllowModNDA\" >#DoesTheGPLAllowModNDA</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1854,6 +1997,10 @@ msgid ""
 "you has the right to redistribute copies (modified or not) of that version.  "
 "You may not distribute any version of the work on a more restrictive basis."
 msgstr ""
+"Não.  A GPL diz que versões modificadas devem transportar toda as liverdades "
+"afirmada na GPL.  Assim, alguém que recebe uma cópia de sua versão de "
+"você tem o direito para redistribuir cópias (modificadas ou não) dessa versão.  "
+"Você pode não distribuir qualquer versão do trabalho sobre um ou mair base restrita."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1861,6 +2008,9 @@ msgid ""
 "agreement? <span class=\"anchor-reference-id\">(<a href="
 "\"#DevelopChangesUnderNDA\" >#DevelopChangesUnderNDA</a>)</span>"
 msgstr ""
+"A GPL me permite desenvolver uma versão modificada sob um acordo de "
+"não divulgação? <span class=\"anchor-reference-id\">(<a href="
+"\"#DevelopChangesUnderNDA\" >#DevelopChangesUnderNDA</a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1869,6 +2019,10 @@ msgid ""
 "permitted because in this case no GPL-covered code is being distributed "
 "under an NDA."
 msgstr ""
+"Sim.  Por exemplo, você pode aceitar um contrato para desenvolver mudanças e não "
+"concordar lançar <em>suas mudanças</em> até que o cliente diga ok.  Isso é "
+"permitido porque nesse caso o código não GPL está sendo distribuído "
+"sob uma NDA."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1877,6 +2031,10 @@ msgid ""
 "too, no GPL-covered code is being distributed under an NDA, or under any "
 "additional restrictions."
 msgstr ""
+"Você pode também lançar suas modificações para o cliente sob a GPL, mas não concordar "
+"lançar para alguém até que o cliente diga ok. Nesse caso, "
+"também, o código não GPL é inicialmente distribuído sob uma NDA, ou sob qualquer "
+"restrições adicionais."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1884,6 +2042,9 @@ msgid ""
 "this scenario, the client will probably choose not to exercise that right, "
 "but does <em>have</em> the right."
 msgstr ""
+"A GPL daria o cliente o direito para redistribuir sua versão. Nesse "
+"cenário, o cliente provavelmente vai optar por não exercer esse direito , "
+"mas ele <em>tem</em> o direito."
 
 #. type: Content of: <dl><dt>
 msgid ""
@@ -1983,6 +2144,9 @@ msgid ""
 "\"anchor-reference-id\">(<a href=\"#LicenseCopyOnly\" >#LicenseCopyOnly</"
 "a>)</span>"
 msgstr ""
+"É suficiente colocar uma cópia do GNU GPL em meu repositório? <span class="
+"\"anchor-reference-id\">(<a href=\"#LicenseCopyOnly\" >#LicenseCopyOnly</"
+"a>)</span>"
 
 #. type: Content of: <dl><dd><p>
 msgid ""
@@ -1992,6 +2156,11 @@ msgid ""
 "permissions in the license really apply to any particular source file.  An "
 "explicit statement saying that eliminates all doubt."
 msgstr ""
+"Colocando uma cópia do GNU GPL em um arquivo em seu repositório não "
+"declara explicitamente que o código no mesmo respositório deve ser usado sob a "
+"GNU GPL.  Sem tal declaração, não está totalmente claro que a "
+"permissão na licença realmente se aplica para qualquer particularidade do arquivo de origem. Uma "
+"declaração explícita esclarecendo todas as dúvidas."
 
 #. type: Content of: <dl><dd><p>
 msgid ""
-- 
2.5.0