From 0920364e8c7e341c1852e3bc9d9505e07d3e8474 Mon Sep 17 00:00:00 2001
From: Benno Schulenberg <bensberg@telfort.nl>
Date: Sun, 3 Mar 2019 11:38:53 +0100
Subject: [PATCH 3/4] docs: describe the new options -J, --marginstripe, and
 'set stripecolor'

---
 doc/nano.1    |  5 +++++
 doc/nano.texi | 17 ++++++++++++++++-
 doc/nanorc.5  | 11 ++++++++++-
 3 files changed, 31 insertions(+), 2 deletions(-)

diff --git a/doc/nano.1 b/doc/nano.1
index ff6d9794..dac22ff1 100644
--- a/doc/nano.1
+++ b/doc/nano.1
@@ -101,6 +101,11 @@ executed commands, so they can be easily reused in later sessions.
 .BR \-I ", " \-\-ignorercfiles
 Don't look at the system's \fInanorc\fR nor at the user's \fInanorc\fR.
 .TP
+.BR \-J\ \fInumber ", " \-\-marginstripe= \fInumber
+Draw a vertical stripe at the given column, to help judge the width of the
+text.  (The color of the stripe can be changed with \fBset stripecolor\fR
+in your \fInanorc\fR file.)
+.TP
 .BR \-K ", " \-\-rawsequences
 Interpret escape sequences directly (instead of asking \fBncurses\fR to
 translate them).  If you need this option to get your keyboard to work
diff --git a/doc/nano.texi b/doc/nano.texi
index 04f28ce9..9db48a54 100644
--- a/doc/nano.texi
+++ b/doc/nano.texi
@@ -190,6 +190,12 @@ executed commands, so they can be easily reused in later sessions.
 @itemx --ignorercfiles
 Don't look at the system's nanorc file nor at the user's nanorc.
 
+@item -J
+@itemx --marginstripe
+Draw a vertical stripe at the given column, to help judge the width of the
+text.  (The color of the stripe can be changed with @code{set stripecolor}
+in your nanorc file.)
+
 @item -K
 @itemx --rawsequences
 Interpret escape sequences directly (instead of asking @code{ncurses} to
@@ -731,7 +737,8 @@ The uniquely numbered files are stored in the specified directory.
 Use bold instead of reverse video for the title bar, status bar, key combos,
 function tags, line numbers, and selected text.  This can be overridden by
 setting the options @code{titlecolor}, @code{statuscolor}, @code{keycolor},
-@code{functioncolor}, @code{numbercolor}, and @code{selectedcolor}.
+@code{functioncolor}, @code{numbercolor}, @code{stripecolor},
+and @code{selectedcolor}.
 
 @item set brackets "@var{string}"
 Set the characters treated as closing brackets when justifying
@@ -799,6 +806,10 @@ Display line numbers to the left of the text area.
 @item set locking
 Enable vim-style lock-files for when editing files.
 
+@item set marginstripe @var{number}
+Draw a vertical stripe at the given column, to help judge the width of the
+text.  (The color of the stripe can be changed with @code{set stripecolor}.)
+
 @item set matchbrackets "@var{string}"
 Set the opening and closing brackets that can be found by bracket
 searches.  This may not include blank characters.  The opening set must
@@ -914,6 +925,10 @@ Use the given program to do spell checking and correcting.
 Use this color combination for the status bar.
 @xref{@code{set functioncolor}} for valid color names.
 
+@item set stripecolor @var{fgcolor},@var{bgcolor}
+Use this color combination for the guiding margin stripe.
+@xref{@code{set functioncolor}} for valid color names.
+
 @item set suspend
 Allow @command{nano} to be suspended.
 
diff --git a/doc/nanorc.5 b/doc/nanorc.5
index 6fa8b14f..e39dbd05 100644
--- a/doc/nanorc.5
+++ b/doc/nanorc.5
@@ -84,7 +84,8 @@ The uniquely numbered files are stored in the specified \fIdirectory\fR.
 Use bold instead of reverse video for the title bar, status bar, key combos,
 function tags, line numbers, and selected text.  This can be overridden by
 setting the options \fBtitlecolor\fP, \fBstatuscolor\fP, \fBkeycolor\fP,
-\fBfunctioncolor\fP, \fBnumbercolor\fP, and \fBselectedcolor\fP.
+\fBfunctioncolor\fP, \fBnumbercolor\fP, \fBstripecolor\fR,
+and \fBselectedcolor\fP.
 .TP
 .B set brackets "\fIstring\fP"
 Set the characters treated as closing brackets when justifying
@@ -145,6 +146,10 @@ Display line numbers to the left of the text area.
 .B set locking
 Enable vim-style lock-files for when editing files.
 .TP
+.B set marginstripe \fInumber
+Draw a vertical stripe at the given column, to help judge the width of the
+text.  (The color of the stripe can be changed with \fBset stripecolor\fR.)
+.TP
 .B set matchbrackets "\fIstring\fP"
 Set the opening and closing brackets that can be found by bracket
 searches.  This may not include blank characters.  The opening set must
@@ -261,6 +266,10 @@ instead of the built-in corrector that calls \fBspell\fR.
 Specify the color combination to use for the status bar.
 See \fBset titlecolor\fR for more details.
 .TP
+.B set stripecolor \fIfgcolor\fR,\fIbgcolor\fR
+Specify the color combination to use for the guiding margin stripe.
+See \fBset titlecolor\fR for more details.
+.TP
 .B set suspend
 Allow \fBnano\fP to be suspended.
 .TP
-- 
2.20.1